unit FindDirs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TFindDirs = class(TComponent)
  private
    { Private declarations }
    FStartDir: String;
    FRecursive: Boolean;
    FDirsFound: TStringList;
    procedure Search(BaseDir: String);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
  published
    { Published declarations }
    property StartDir: String read FStartDir write FStartDir;
    property Recursive: Boolean read FRecursive write FRecursive default True;
    property DirsFound: TStringList read FDirsFound write FDirsFound;
  end;

procedure Register;

implementation

{ $R *.dcr}

constructor TFindDirs.Create(AOwner: TComponent);
begin
 inherited;
 FRecursive := True;
 FStartDir := '';
 FDirsFound := TStringList.Create;
 FDirsFound.Clear;
end;

destructor TFindDirs.Destroy;
begin
 FDirsFound.Clear;
 FDirsFound.Free;
 inherited;
end;

procedure TFindDirs.Search(BaseDir: String);
var SearchRec: TSearchRec;
    DosError: Integer;
begin
 {Let's find the first directory}
 DosError := FindFirst('*.*', faDirectory, SearchRec);
 while DosError = 0 do
  begin
   if ((SearchRec.Attr and faDirectory = faDirectory) and
      (SearchRec.Name <> '.') and (SearchRec.Name <> '..'))
    then
     begin
      if FRecursive
       then
        begin
         ChDir(SearchRec.Name);
         Search(BaseDir+'\'+SearchRec.Name); {Time for the recursion! (No need for result, already have 1 dir)}
         ChDir('..'); {Down one level}
        end;
      FDirsFound.Add(BaseDir+'\'+SearchRec.Name);
     end;
   DosError := FindNext(SearchRec); {Look for the next directory}
  end;
 FindClose(SearchRec);
end;

function TFindDirs.Execute: Boolean;
begin
 {$I-}
 ChDir(FStartDir);
 {$I+}
 if IOResult = 0
  then Search(FStartDir)
  else Execute := False;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TFindDirs]);
end;

end.
